<?php
# dynamische Klasse Bier, zur Veranschaulichung
# https://www.php.net/manual/de/oop5.intro.php
# fuer Johannes 'Iwan' Hauser
# in Klassen generell:
# Eigenschaften/Properties/Props: Variablen (Skalare, Arrays, ...)
# Methoden/methods: Funktionen

	# ein Interface ist ein Kontrakt
	# diese Fkts werden von der Klasse oeffentlich bereitgestellt
	# oder wir werden fehlschlagen

	interface IBier {
		function zeigeMarke();
		function zeigeVorrat();

		function Trinke($menge);
		function Braue();
	}

	# Klasse haelt alles zusammen
	class Bier implements IBier {
		# public    - von ueberall
		# private   - nur aus dieser Klasse
		# protected - alle Kinder, dies + Elter

		# static  - verzichtet auf $this
		# dynamic - Gegenteil, alle hier

		private $Marke = '';   # private: nie von aussen in die Klasse graetschen!
		private $Flaschen = 0; # private: nie von aussen in die Klasse graetschen!
		private $zaehler = 0;  # private: nie von aussen in die Klasse graetschen!
		
		# __construct laeuft, wenn ich 'new' sage
		# __construct ist eine magische Methode!
		public function __construct() {
			# ich lasse mir doch nicht vorschreiben, wie meine Init-Funktion heissen soll! ;)
			$this->holen(); # Für Vorrat sorgen ;)

			# Aufhuebschung
			echo '<STYLE type="TEXT/CSS">dl {display:flex;} dt,dd {margin:0;padding:0;}dt {width:100px;}</STYLE>';
		}

		# private: niemand ausser uns geht Bier holen ;(
		# wird ueber __construct implementiert
		private function holen() {
			$Marken = array('Gaffel','Früh','Gilden','Mühlen','Sion','Sester','Ganser');
			$idx = array_rand($Marken,1); # waehle eine zufaellige Koelsch-Marke
			$this->Marke = $Marken[$idx]; # waehle eine zufaellige Koelsch-Marke
			$this->Flaschen = rand(1,6);  # waehle einen zufaelligen Koelsch-Vorrat
		}

		# public: jeder darf unsere Biermarke sehen
		public function zeigeMarke() {
			$this->zaehler++;
			$ausgabe = array('<dl>');
			$ausgabe[] = '<dt>' . $this->zaehler . '. Marke</dt>';
			$ausgabe[] = '<dd>' . $this->Marke . ' Kölsch</dd>';
			$ausgabe[] = '</dl>';

			# Vorsicht, echo 'druckt' sofort!
			echo implode(chr(10), $ausgabe);
		}

		# public: jeder darf unseren Vorrat sehen
		public function zeigeVorrat() {
			$this->zaehler++;
			$ausgabe = array('<dl>');
			$ausgabe[] = '<dt>' . $this->zaehler . '. Vorrat</dt>';
			$ausgabe[] = '<dd>' . $this->Flaschen . ' Flaschen</dd>';
			$ausgabe[] = '</dl>';

			# Vorsicht, echo 'druckt' sofort!
			echo implode(chr(10), $ausgabe);
		}

		# public: jeder darf brauen
		public function Braue() {
			$this->zaehler++;
			$ausgabe = array('<dl>');
			$erg = rand(1,6); # waehle eine zufaelligen Flaschen-Anzahl
			$this->Flaschen += $erg; # addiere diese Anzahl

			$ausgabe[] = '<dt>' . $this->zaehler . '. Braue</dt>';
			$ausgabe[] = '<dd>' . $erg . ' Flaschen</dd>';
			$ausgabe[] = '</dl>';

			# Vorsicht, echo 'druckt' sofort!
			echo implode(chr(10), $ausgabe);
		}
		
		# public: jeder darf trinken
		public function Trinke($menge) {
			$this->zaehler++;
			$ausgabe = array('<dl>');
			$ausgabe[] = '<dt>' . $this->zaehler . '. Trinke</dt>';
			if($this->Flaschen < $menge) {
				$ausgabe[] = '<dd>' . $menge . ' Flaschen: geht nicht, zuwenig Bier!</dd>';
			} else {
				$ausgabe[] = '<dd>' . $menge . ' Flaschen: Lecker!</dd>';
			}
			$ausgabe[] = '</dl>';

			# Vorsicht, echo 'druckt' sofort!
			echo implode(chr(10), $ausgabe);
		}
	}
?>
